LPARAMETERS loObject, lcMessage, lcTitle, lnTimeOut, lnIcon, lnPosition, lnMaxWidth, lnBackColor, lnForeColor
loForm = IIF(UPPER(loObject.BaseClass)='FORM',loObject,ObjForm(loObject))
IF TYPE('loForm.Balloon.Title') = 'C'
	loForm.Balloon=.F.
ENDIF

IF TYPE('loForm.Balloon.Title') # 'C'
	loForm.ADDPROPERTY('Balloon',CREATEOBJECT("Balloon",loForm))
ENDIF

WITH loForm.Balloon
	.TIMEOUT=ROUND(EVL(lnTimeOut,3)*1000,0)

	IF NOT EMPTY(lcTitle)
		.TITLE=totext(lcTitle)
	ENDIF

	.ICON=EVL(lnIcon,0)

	IF TYPE('lnBackColor')='N'
		.BACKCOLOR=lnBackColor
	ENDIF

	IF TYPE('lnForeColor')='N'
		.FORECOLOR=lnForeColor
	ENDIF

	IF TYPE('lnPosition')='N' OR EMPTY(lnPosition)
		.Position=EVL(lnPosition,3)
	ENDIF

	IF TYPE('lnMaxWidth')='N' OR EMPTY(lnMaxWidth)
		lnMaxWidth=EVL(lnMaxWidth,_screen.Width*0.8)
	ENDIF
	

	IF NOT EMPTY(lcMessage)
		lcMessage=totext(lcMessage)
		IF lnMaxWidth<0
			.TEXT=totext(lcMessage)
			.SetPoint(loObject)
			.SHOW()
		ELSE
			lcMessage=preballoon(lcMessage,lnMaxWidth)
			.TEXT=totext(lcMessage)
			.SetPoint(loObject)
			.SHOW()
		ENDIF
	ENDIF
ENDWITH
#DEFINE LF_FACESIZE			32

#DEFINE WM_LBUTTONDOWN      0x201
#DEFINE WM_USER             0x0400
#Define WM_GETFONT        	0x31

#DEFINE SWP_NOSIZE          0x0001
#DEFINE SWP_NOMOVE          0x0002
#DEFINE SWP_NOZORDER        0x0004
#DEFINE SWP_NOREDRAW        0x0008
#DEFINE SWP_NOACTIVATE      0x0010
#DEFINE SWP_FRAMECHANGED    0x0020
#DEFINE SWP_SHOWWINDOW      0x0040
#DEFINE SWP_HIDEWINDOW      0x0080
#DEFINE SWP_NOCOPYBITS      0x0100
#DEFINE SWP_NOOWNERZORDER   0x0200
#DEFINE SWP_NOSENDCHANGING  0x0400

#DEFINE TTS_ALWAYSTIP           0x01
#DEFINE TTS_NOPREFIX            0x02
#DEFINE TTS_NOANIMATE           0x10
#DEFINE TTS_NOFADE              0x20
#DEFINE TTS_BALLOON             0x40
#DEFINE TTS_CLOSE               0x80

#DEFINE TTM_ACTIVATE            (WM_USER + 1)
#DEFINE TTM_SETDELAYTIME        (WM_USER + 3)
#DEFINE TTM_ADDTOOLA            (WM_USER + 4)
#DEFINE TTM_ADDTOOLW            (WM_USER + 50)
#DEFINE TTM_DELTOOLA            (WM_USER + 5)
#DEFINE TTM_DELTOOLW            (WM_USER + 51)
#DEFINE TTM_NEWTOOLRECTA        (WM_USER + 6)
#DEFINE TTM_NEWTOOLRECTW        (WM_USER + 52)
#DEFINE TTM_RELAYEVENT          (WM_USER + 7)

#DEFINE TTM_GETTOOLINFOA        (WM_USER + 8)
#DEFINE TTM_GETTOOLINFOW        (WM_USER + 53)

#DEFINE TTM_SETTOOLINFOA        (WM_USER + 9)
#DEFINE TTM_SETTOOLINFOW        (WM_USER + 54)

#DEFINE TTM_HITTESTA            (WM_USER +10)
#DEFINE TTM_HITTESTW            (WM_USER +55)
#DEFINE TTM_GETTEXTA            (WM_USER +11)
#DEFINE TTM_GETTEXTW            (WM_USER +56)
#DEFINE TTM_UPDATETIPTEXTA      (WM_USER +12)
#DEFINE TTM_UPDATETIPTEXTW      (WM_USER +57)
#DEFINE TTM_GETTOOLCOUNT        (WM_USER +13)
#DEFINE TTM_ENUMTOOLSA          (WM_USER +14)
#DEFINE TTM_ENUMTOOLSW          (WM_USER +58)
#DEFINE TTM_GETCURRENTTOOLA     (WM_USER + 15)
#DEFINE TTM_GETCURRENTTOOLW     (WM_USER + 59)
#DEFINE TTM_WINDOWFROMPOINT     (WM_USER + 16)
#DEFINE TTM_TRACKACTIVATE       (WM_USER + 17)  && wParam = TRUE/FALSE start end  lparam = LPTOOLINFO
#DEFINE TTM_TRACKPOSITION       (WM_USER + 18)  && lParam = dwPos
#DEFINE TTM_SETTIPBKCOLOR       (WM_USER + 19)
#DEFINE TTM_SETTIPTEXTCOLOR     (WM_USER + 20)
#DEFINE TTM_GETDELAYTIME        (WM_USER + 21)
#DEFINE TTM_GETTIPBKCOLOR       (WM_USER + 22)
#DEFINE TTM_GETTIPTEXTCOLOR     (WM_USER + 23)
#DEFINE TTM_SETMAXTIPWIDTH      (WM_USER + 24)
#DEFINE TTM_GETMAXTIPWIDTH      (WM_USER + 25)
#DEFINE TTM_SETMARGIN           (WM_USER + 26)  && lParam = lprc
#DEFINE TTM_GETMARGIN           (WM_USER + 27)  && lParam = lprc
#DEFINE TTM_POP                 (WM_USER + 28)
#DEFINE TTM_UPDATE              (WM_USER + 29)

#DEFINE TTM_SETTITLEA           (WM_USER + 32)  && wParam = TTI_*, lParam = char* szTitle
#DEFINE TTM_SETTITLEW           (WM_USER + 33)  && wParam = TTI_*, lParam = wchar* szTitle

#DEFINE TTF_CENTERTIP           0x0002
#DEFINE TTF_RTLREADING          0x0004
#DEFINE TTF_SUBCLASS            0x0010
#DEFINE TTF_TRACK               0x0020
#DEFINE TTF_ABSOLUTE            0x0080
#DEFINE TTF_TRANSPARENT         0x0100
#DEFINE TTF_PARSELINKS          0x1000
#DEFINE TTF_DI_SETITEM          0x8000     &&  // valid only on the TTN_NEEDTEXT callback



DEFINE CLASS Balloon AS CUSTOM
	TOP=0			&& Top coordinate of ToolTip
	LEFT=0			&& Left coordinate of ToolTip
	ALIGNMENT=0		&& 0 - left, 1 - right
	TITLE=""		&& ToolTips Title
	TEXT=""			&& ToolTips Text
	Icon=0			&& 0 - No Icon, 1 - Info, 2 - Warning, 3 - Error
	Style=1			&& 0 - Simple style, 1 - Ballon Style
	ForeColor=0		&& Text Color
	BackColor=Rgb(255,255,192)
	TimeOut=0		&& Timeout to Hide ToolTip
	Position=lnPosition
	loForm=.f.

	Hwnd=0			&& Hadle of ToolTips window
	HosthWnd=0
	ToolInfo=""		&& TOOLINFO structure
	hMEM=0			&& memory handle
	Visible=.f.
	Active=.f.
	VFPWndProc=	0
	FontName='Tahoma'
	FontSize=10

	Add Object Timer as Timer

	PROCEDURE Init
	LPARAMETERS loForm
	WITH THIS
		.loForm=loForm
		.DeclareDlls()
		.HosthWnd=loForm.HWND
		BINDEVENT(.HosthWnd, WM_LBUTTONDOWN, THIS, "_MsgHandler_Host_WM_LBUTTONDOWN", 1)
		BINDEVENT(loForm, 'Moved', THIS, "Hide")
		BINDEVENT(loForm, 'Resize', THIS, "Hide")
		.VFPWndProc=GetWindowLong(_VFP.HWND, -4)
	ENDWITH

	HIDDEN PROCEDURE CreateWindow
		LOCAL lc, lcLogFont, lnDC, lnFont, lnLogPixelsY
		WITH THIS
	* Create Balloon class window
			DestroyWindow(.HWND)

			.HWND=CreateWindowEx;
				(0;
				,"tooltips_class32";
				,'';
				, 368 ;
				,0x80000000,0x80000000,0x80000000,0x80000000,0,0,4194304,GetWindowLong(_VFP.HWND, -6))
	**			, TTS_NOPREFIX+TTS_ALWAYSTIP+Iif(.Style=1,TTS_BALLOON,0) ;

	DECLARE INTEGER SendMessage IN win32api AS SendMessageN ;
		INTEGER HWND,;
		INTEGER Msg,;
		INTEGER wParam,;
		INTEGER LPARAM
DECLARE INTEGER GetDeviceCaps   IN WIN32API ;
	INTEGER iHDC, INTEGER iIndex
m.lnFont = SendMessageN(.Hwnd, WM_GETFONT, 0, 0)
m.lcLogFont=SPACE(60)
_Getobject(m.lnFont, LEN(m.lcLogFont), @m.lcLogFont)
.FontName = Chrtran(Substr(m.lcLogFont, 29, LF_FACESIZE), Chr(0), [])

m.lnDC = GetDC(0)
lnLogPixelsY = GetDeviceCaps(m.lnDC, 90)
ReleaseDC(0, m.lnDC)
lc=._StringToNumber(Substr(m.lcLogFont,  1, 4))
.FontSize=Round(72 * lc / lnLogPixelsY * (-1), 0)
		ENDWITH

	HIDDEN PROCEDURE SetToolInfo
		WITH THIS
			.AllocateMemory(.TEXT)
	* Fill TOOLINFO structure with Alingment property
			.ToolInfo=;
				.B2C(44,4)+;
				.B2C(TTF_TRACK+IIF(.ALIGNMENT=1,TTF_CENTERTIP,0),4)+;
				.B2C(0,4)+;
				.B2C(0,4)+;
				.B2C(0,4)+;
				.B2C(0,4)+;
				.B2C(0,4)+;
				.B2C(0,4)+;
				.B2C(0,4)+;
				.B2C(.HMEM,4)+;
				.B2C(0,4)
		ENDWITH

	HIDDEN PROCEDURE AllocateMemory(lcText)
		WITH THIS
			lcText=lcText+CHR(0)
			GlobalFree(.HMEM)
			.HMEM=GlobalAlloc(0,LEN(lcText))
			RtlMoveMemory(.HMEM,@lcText,LEN(lcText))
		ENDWITH

	PROCEDURE SetPoint(loObject)
		WITH THIS
	* Calculate coordinates to Screen coordinates
			LOCAL lnTop, lnLeft
IF UPPER(loObject.BaseClass)='FORM'
m.lnTop=MROW(loObject.Name,3)
m.lnLeft=MCOL(loObject.Name,3)
			=.CalcLeftTop(@lnLeft,@lnTop)
			.TOP = INT(m.lnTop)
			.LEFT=lnLeft

.ALIGNMENT=1
RETURN
ENDIF

			DO CASE
				CASE .Position=1
					lnWidthKoef=0
					lnHeightKoef=1
				CASE .Position=2
					lnWidthKoef=0.5
					lnHeightKoef=1
				CASE .Position=4
					lnWidthKoef=0
					lnHeightKoef=0.5
				CASE .Position=5
					lnWidthKoef=0.5
					lnHeightKoef=0.5
				CASE .Position=6
					lnWidthKoef=1
					lnHeightKoef=0.5
				CASE .Position=7
					lnWidthKoef=0
					lnHeightKoef=0
				CASE .Position=8
					lnWidthKoef=0.5
					lnHeightKoef=0
				CASE .Position=9
					lnWidthKoef=1
					lnHeightKoef=0
				OTHERWISE
					lnWidthKoef=1
					lnHeightKoef=1
			ENDCASE
			.ALIGNMENT=IIF(INLIST(.Position,2,5,8),1,0)
			lnTop= Obj2Client(loObject,1)
			IF lnTop>=4000 AND TYPE('loObject.parent.parent.recordsource')='C'
				WITH loObject.PARENT.PARENT
					IF .ACTIVECOLUMN=0
						.SETFOCUS
					ENDIF
					lnActiveColumn = .ACTIVECOLUMN
					lnTop=Obj2Client(.COLUMNS(lnActiveColumn).text1,1)
					lnHeight=Obj2Client(.COLUMNS(lnActiveColumn).text1,4)

					lnLeft=Obj2Client(.COLUMNS(lnActiveColumn).text1,2)

					IF lnLeft<4000*0
						lnWidth=Obj2Client(.COLUMNS(lnActiveColumn).text1,3)
					ELSE
						lnLeft=Obj2Client(.COLUMNS(lnActiveColumn).text1,2)+IIF(.RECORDMARK,10+.GRIDLINEWIDTH,0)	;
							+ IIF(.DELETEMARK,8+.GRIDLINEWIDTH,0)+1
						FOR lnColumn=.LEFTCOLUMN TO loObject.PARENT.COLUMNORDER-1
							lnLeft=lnLeft+.COLUMNS(lnColumn).WIDTH+.GRIDLINEWIDTH
						NEXT
						lnWidth=.COLUMNS(loObject.PARENT.COLUMNORDER).WIDTH-.GRIDLINEWIDTH*2
					ENDIF
				ENDWITH
			ELSE
				lnWidth=Obj2Client(loObject,3)
				lnHeight=Obj2Client(loObject,4)
				lnLeft=Obj2Client(loObject,2)
			ENDIF

			m.lnTop=m.lnTop+m.lnHeight*m.lnHeightKoef - .loForm.VIEWPORTTOP
			lnLeft=lnLeft+lnWidth*lnWidthKoef

			=.CalcLeftTop(@lnLeft,@lnTop)
			.TOP = INT(m.lnTop)
			.LEFT=lnLeft

		ENDWITH


	PROCEDURE SHOW
		WITH THIS
	* If Window does not exist - create it
		IF .HWND = 0
				.CreateWindow()
			ENDIF
	* Fill TOOLINFO Structure
			.SetToolInfo()

			LOCAL lcToolInfo, lcTitle
			lcToolInfo=.ToolInfo

	* Add Tool ANSI
			SendMessageC(.HWND,TTM_ADDTOOLA,0,@lcToolInfo)

	* Set Colors of ToolTip
			SendMessage(.HWND,TTM_SETTIPTEXTCOLOR,.FORECOLOR,0)
			IF NOT EMPTY(.BACKCOLOR)
				SendMessage(.HWND,TTM_SETTIPBKCOLOR,.BACKCOLOR,0)
			ENDIF
	* Set Title of ToolTip
			IF NOT EMPTY(.TITLE)
				lcTitle=.TITLE
				SendMessageC(.HWND,TTM_SETTITLEA,.ICON,@lcTitle)
			ENDIF

	* Track position of ToolTip
			SendMessage(.HWND,TTM_TRACKPOSITION,0,BITLSHIFT(.TOP,16)+.LEFT)
	* Activate Tracking
			SendMessageC(.HWND,TTM_TRACKACTIVATE,1,@lcToolInfo)
			THIS.VISIBLE =.T.
*say(this.Left ,this.Top ,this.Width ,this.Height, .visible, [this.Left ,this.Top ,this.Width ,this.Height, .visible])
			.TIMER.INTERVAL=.TIMEOUT
		ENDWITH

	PROCEDURE HIDE
		LPARAMETERS llVisible,lp1,lp2,lp3,lp4,lp5
		WITH THIS
			IF .HWND # 0 AND IsWindowVisible(.HWND)=1
				SendMessage(.HWND, TTM_TRACKACTIVATE,0,0)
			ENDIF
			THIS.VISIBLE =.F.
		ENDWITH

	PROCEDURE TimeOut_Assign(lnTimeOut)
		WITH THIS
			.TIMEOUT=lnTimeOut
			.TIMER.INTERVAL=lnTimeOut
		ENDWITH

	PROCEDURE TIMER.TIMER
		WITH THIS.PARENT
			.HIDE()
			.TIMER.INTERVAL=0
		ENDWITH

	PROCEDURE DESTROY
		WITH THIS
			GlobalFree(.HMEM)
			DestroyWindow(.HWND)
		ENDWITH


	PROCEDURE B2C(m.Val,m.Len)
		LOCAL i, m.Ret
		m.Len=IIF(EMPTY(m.Len),4,m.Len)
		m.Ret=""
		DO WHILE m.Val # 0
			m.Ret=m.Ret+CHR(MOD(m.Val,256))
			m.Val=BITRSHIFT(m.Val,8)
		ENDDO
		RETURN IIF(EMPTY(m.Len),m.Ret,PADR(m.Ret,m.Len,CHR(0)))

	PROCEDURE C2B( m.str)
		LOCAL N, i
		N=0
		FOR i=LEN(m.str) TO 1 STEP -1
			N=BITLSHIFT(N,8)+ASC(SUBSTR(m.str,i,1))
		NEXT
		RETURN N



FUNCTION _MsgHandler_Host_WM_LBUTTONDOWN
*!*	 mouseclick  . The Balloontip transfers its mouse events to the form
*!*	HWND. When the user clicks on the form or the balloontip, we hide the balloontip.
*!*	IF the user clicked on the form, the form gets the click. If the user clicked on the balloontip
*!*	we discard the click to prevent undesired clicks on the underlying form. For example, if underneath
*!*	the balloontip there is a button, and the user clicks the balloontip to hide it, the button
*!*	will get the click. This method prevents that.

	LPARAMETERS nHWND AS INTEGER, nMSG AS INTEGER, nWPARAM AS INTEGER, nLPARAM AS INTEGER
	LOCAL lnResult AS NUMBER, lnX, lnY, lcPoint, lnOption, loRect, lcRect
	m.lnOption = -1		&& not used


*If This.Visible
	THIS.HIDE()
*RETURN

	m.lnOption = 0		&& do not discard click

*!* Get form coordinates of mouse click from lParam

	m.lnX = BITAND(m.nLPARAM, 0xFFFF)
	m.lnY = BITRSHIFT(m.nLPARAM, 16)

*!* Convert form coordinates to screen coordinates:
	m.lcPoint = BINTOC(m.lnX, [4RS]) + BINTOC(m.lnY, [4RS])

*!* 20070603 Changed Thisform.hWnd to This._HosthWnd
	ClientToScreen(THIS.HostHWnd, @m.lcPoint)
	m.lnX = CTOBIN(SUBSTR(m.lcPoint, 1, 4), [4RS])
	m.lnY = CTOBIN(SUBSTR(m.lcPoint, 5, 4), [4RS])

*!* WindowFromPoint only works on XP and up, in 98 and 2K returns hwnd of form
	IF VAL(OS(3)) * 1000000 + VAL(OS(4)) * 10000 + VAL(OS(8)) * 100 + VAL(OS(9)) =777 &&>= 5010000
*!* We will check if the mouse click is in the ballontip or in the form
*!* If the mouse click is on the balloontip, we do not pass the click to the form
		DECLARE INTEGER WindowFromPoint IN win32api;
			INTEGER xPoint,;
			INTEGER yPoint
		IF WindowFromPoint(m.lnX, m.lnY) = THIS.HWND
			m.lnOption = 1	&& discard
		ENDIF
	ELSE
*!* Not XP, use WindowRect that is not as exact, but close
*!*	*!*			m.lcRect = This.oRect._Struct
*!*	*!*			GetWindowRect(This.Hwnd, @m.lcRect)
*!*	*!*			This.oRect._Struct = m.lcRect
*!*	*!*			If Between(m.lnY, This.oRect._Top, This.oRect._Bottom) And ;
*!*	*!*					between(m.lnX, This.oRect._Left, This.oRect._Right)
*!*	*!*				m.lnOption = 1 	&& Discard
*!*	*!*			Endif
	ENDIF

*!* Hide BalloonTip
*	This.Hide()

*Endif

	DO CASE

		CASE m.lnOption = -1	&& BalloonTip not visible and active
			m.lnResult  = CallWindowProc(THIS.VFPWndProc, m.nHWND, m.nMSG, m.nWPARAM, m.nLPARAM)

		CASE m.lnOption = 0		&& BalloonTip visible, click was outside balloontip

			m.lnResult  = CallWindowProc(THIS.VFPWndProc, m.nHWND, m.nMSG, m.nWPARAM, m.nLPARAM)
			RAISEEVENT(THIS, "Hide", 2)

		CASE m.lnOption = 1		&& BalloonTip visible, click was inside balloontip
			m.lnResult  = 1
			RAISEEVENT(THIS, "Hide", 1)
	ENDCASE

	RETURN m.lnResult

FUNCTION _MsgHandler_Form_WM_KEYDOWN
	LPARAMETERS nHWND AS INTEGER, nMSG AS INTEGER, nWPARAM AS INTEGER, nLPARAM AS INTEGER

	LOCAL lnResult AS NUMBER

*If This.Active
	IF THIS.VISIBLE
		THIS.VISIBLE = .F.
		RAISEEVENT(THIS, "Hide", 4)
	ENDIF

*Endif

	m.lnResult  = CallWindowProc(THIS.VFPWndProc, m.nHWND, m.nMSG, m.nWPARAM, m.nLPARAM)

	RETURN m.lnResult

FUNCTION CalcLeftTop
LPARAMETERS m.lnLeft,m.lnTop
m.lcPoint = BinToC(m.lnLeft,[4RS])+ BinToC(m.lnTop,[4RS])
m.nHWnd = m.loForm.HWnd

*!* If the form is a top level form, or it has scrollbars, get hWnd of inner window:
    If m.loForm.ShowWindow = 2 Or m.loForm.ScrollBars > 0
        *!* Get hWnd of client window of Top Level Form //Craig Boyd//
        m.nHWnd = Sys(2327, Sys(2325, Sys(2326, This.HostHWnd)))
    Endif
ClientToScreen(m.nHWnd, @m.lcPoint)

m.lnLeft = CToBin(Substr(m.lcPoint, 1, 4), [4RS])
m.lnTop =  CToBin(Substr(m.lcPoint, 5, 4), [4RS])

FUNCTION _StringToNumber
Lparameters m.tcCharInt As String, m.tlUnsigned As Boolean, m.tlNoReverse As Boolean

Local ;
    m.lnx As Number, ;
    m.lnRetVal As Number, ;
    m.lnChars As Number, ;
    m.llBig As Boolean, ;
    m.lnPower As Integer

m.lnRetVal = 0
m.lnChars = Len(m.tcCharInt)

If m.lnChars > 0 Then

    For m.lnx = 1 To m.lnChars

        If m.tlNoReverse = .T. Then
            m.lnPower = m.lnChars - m.lnx
        Else
            m.lnPower = m.lnx - 1
        Endif

        m.lnRetVal = m.lnRetVal + (Asc(Substr(m.tcCharInt, m.lnx, 1)) * (256 ^ (m.lnPower)))
    Next

    m.llBig = m.lnRetVal > Evaluate([0x7F] + Replicate([FF], m.lnChars-1))

    If m.tlUnsigned = .F. And m.llBig
        m.lnRetVal = m.lnRetVal - 1 - Evaluate([0x] + Replicate([FF], m.lnChars))
    Endif
Endif

Return Int(m.lnRetVal)

FUNCTION DeclareDlls
LOCAL ARRAY laDeclaredDlls(1,3)
LOCAL lnLen AS NUMBER
m.lnLen = ADLLS(m.laDeclaredDlls)

If Ascan(m.laDeclaredDlls, "ClientToScreen", 1, m.lnLen , 2, 15) = 0
    Declare Integer ClientToScreen In win32api ;
        Integer nHWnd, ;
        String  @lpPoint
Endif
IF ASCAN(m.laDeclaredDlls, [SendMessageN], 1, m.lnLen , 2, 15) = 0
	DECLARE INTEGER SendMessage IN win32api AS SendMessageN ;
		INTEGER HWND,;
		INTEGER Msg,;
		INTEGER wParam,;
		INTEGER LPARAM
ENDIF

IF ASCAN(m.laDeclaredDlls, [ReleaseDC], 1, m.lnLen , 2, 15) = 0
	DECLARE INTEGER ReleaseDC IN win32api ;
		INTEGER HWND, ;
		INTEGER hdc
ENDIF

IF ASCAN(m.laDeclaredDlls, [_GetObject], 1, m.lnLen , 2, 15) = 0
    DECLARE INTEGER GetObject In win32api As _GetObject;
        Integer hObject,;
        Integer nCount,;
        String  @lpObject
ENDIF

IF ASCAN(m.laDeclaredDlls, [GetWindowLong], 1, m.lnLen , 2, 15) = 0
	DECLARE LONG 	GetWindowLong 		IN Win32Api INTEGER, INTEGER
ENDIF 

IF ASCAN(m.laDeclaredDlls, [CreateWindowEx], 1, m.lnLen , 2, 15) = 0
	Declare Integer CreateWindowEx In user32 ;
		    Integer	dwExStyle, ;	&& extended window style
			String @lpClassName, ;	&& address of registered class name
		    String @lpWindowName, ;	&& address of window name
	    	Long	dwStyle, ;		&& window style
		    Integer	x, ;			&& horizontal position of window
	    	Integer	y, ;			&& vertical position of window
		    Integer	nWidth,	;		&& window width
	    	Integer nHeight, ;		&& window height
		    Integer hWndParent, ;	&& handle of parent or owner window
	    	Integer	hMenu, ;		&& handle of menu or child-window identifier
		    Integer	hInstance, ;	&& handle of application instance
	    	Long	lpParam 		&& address of window-creation data
ENDIF

IF ASCAN(m.laDeclaredDlls, [IsWindowVisible], 1, m.lnLen , 2, 15) = 0
	Declare Integer	IsWindowVisible In Win32API ;
			Integer	hWnd 			&& handle of window
ENDIF

IF ASCAN(m.laDeclaredDlls, [DestroyWindow], 1, m.lnLen , 2, 15) = 0
	Declare Integer DestroyWindow In Win32API ;
			Integer hWnd			&& handle of window to destroy
ENDIF

IF ASCAN(m.laDeclaredDlls, [SendMessage], 1, m.lnLen , 2, 15) = 0
	Declare Integer	SendMessage In Win32API ;
		    Integer	hwnd,;			&& handle of destination window
	    	Integer	uMsg, ;			&& message to send
		    Integer	wParam,;		&& first message parameter
	    	Long	lParam 			&& second message parameter
ENDIF

IF ASCAN(m.laDeclaredDlls, [GetLastError], 1, m.lnLen , 2, 15) = 0
	Declare Integer GetLastError In Win32API
ENDIF

IF ASCAN(m.laDeclaredDlls, [SendMessage], 1, m.lnLen , 2, 15) = 0
	Declare Integer	SendMessage In Win32API as SendMessageC ;
		    Integer	hwnd,;			&& handle of destination window
	    	Integer	uMsg, ;			&& message to send
		    Integer	wParam,;		&& first message parameter
	    	String @ lParam 		&& second message parameter
ENDIF


IF ASCAN(m.laDeclaredDlls, [GlobalAlloc], 1, m.lnLen , 2, 15) = 0
	Declare Integer GlobalAlloc in Win32api integer, integer
ENDIF

IF ASCAN(m.laDeclaredDlls, [GlobalFree], 1, m.lnLen , 2, 15) = 0	
	Declare Integer GlobalFree in Win32api integer
ENDIF

IF ASCAN(m.laDeclaredDlls, [RtlMoveMemory], 1, m.lnLen , 2, 15) = 0
	Declare Integer RtlMoveMemory in Win32Api integer, string @,  integer
ENDIF

IF ASCAN(m.laDeclaredDlls, [CallWindowProc], 1, m.lnLen , 2, 15) = 0
    Declare Integer CallWindowProc In win32api ;
        Integer lpPrevWndFunc,;
        Integer nHWnd,;
        Integer msg,;
        Integer wParam,;
        Integer Lparam
ENDIF
If Ascan(m.laDeclaredDlls, [GetDC], 1, m.lnLen , 2, 15) = 0
    Declare Integer GetDC In win32api ;
        Integer nHWnd
Endif


ENDDEFINE

FUNCTION PreBalloon
LPARAMETERS lcMessage, lnMaxWidth, lcFontName, lnFontSize
LOCAL lcInsteadTab, lcNew, lcPart, lcStr, lcWord, 	;
	lnAverageWidth, lnLine, lnWord

lnMaxWidth=EVL(lnMaxWidth,(_SCREEN.Width-60))
lcFontName=EVL(lcFontName,'Tahoma')
lnFontSize=EVL(lnFontSize,10)
lnAverageWidth=FONTMETRIC(6,lcFontName,lnFontSize)
lcInsteadTab = SPACE(3)

lcNew=''
FOR lnLine=1 TO ALINES(la,lcMessage)
	lcStr = la(lnline)
	IF EMPTY(lcStr)
		lcNew =lcNew+CHR(13)+CHR(10)
		LOOP
	ENDIF
	lcPart=''
	FOR lnWord=1 TO ALINES(la2,lcStr,' ')
		lcWord = la2(lnWord)
		IF TXTWIDTH(STRTRAN(lcPart+' '+lcWord,CHR(9),lcInsteadTab),lcFontName,lnFontSize)* lnAverageWidth > lnMaxWidth
			TEXT TO lcNew ADDITIVE
<<lcPart+CHR(13)+CHR(10)>>
			ENDTEXT
			lcPart=lcWord
			ELSE
			lcPart = lcPart + IIF(EMPTY(lcPart),'',' ')+lcWord
		ENDIF
	NEXT
	IF NOT EMPTY(lcPart)
		TEXT TO lcNew ADDITIVE
<<lcPart+CHR(13)+CHR(10)>>
		ENDTEXT
	ENDIF
NEXT

RETURN STRTRAN(lcNew,CHR(9),lcInsteadTab)
